%global upstreamver 1r2p2
%global pkgname ctbllib

Name:           gap-pkg-%{pkgname}
Version:        %(sed -r "s/r|p/./g" <<< %upstreamver)
Release:        5%{?dist}
Summary:        GAP Character Table Library

License:        GPLv2+
URL:            http://www.math.rwth-aachen.de/~Thomas.Breuer/%{pkgname}/
Source0:        http://www.math.rwth-aachen.de/~Thomas.Breuer/%{pkgname}/%{pkgname}-%{upstreamver}.tar.gz
BuildArch:      noarch

BuildRequires:  gap-devel
BuildRequires:  gap-pkg-browse
BuildRequires:  gap-pkg-tomlib
BuildRequires:  parallel
BuildRequires:  procps

Requires:       gap-core

Recommends:     gap-pkg-browse
Recommends:     gap-pkg-tomlib
Recommends:     gap-pkg-spinsym

# This can be removed once Fedora 21 reaches EOL
Obsoletes:      gap-character-tables < 1.2.2-1%{?dist}
Provides:       gap-character-tables = %{version}-%{release}

%description
This package provides the Character Table Library by Thomas Breuer.

%prep
%setup -q -n %{pkgname}

%build
# Compress large tables
parallel %{?_smp_mflags} --no-notice gzip --best ::: data/*.tbl

# Link to main GAP documentation
cp -a %{_gap_dir}/doc ../../doc
cp -a %{_gap_dir}/pkg/atlasrep ../atlasrep
cp -a %{_gap_dir}/pkg/Browse ../Browse
pushd doc
gap makedocrel.g
popd
rm -fr ../{atlasrep,Browse} ../../doc

%install
mkdir -p %{buildroot}%{_gap_dir}/pkg/%{pkgname}
cp -a ../%{pkgname} %{buildroot}%{_gap_dir}/pkg
rm -fr %{buildroot}%{_gap_dir}/pkg/%{pkgname}/{gap3,README}
rm -f %{buildroot}%{_gap_dir}/pkg/%{pkgname}/doc/*.{aux,bbl,blg,brf,idx,ilg,ind,log,out,pnr,toc}

%check
# Basic installation test
gap -l "%{buildroot}%{_gap_dir};%{_gap_dir}" << EOF 2>&1 | tee log
ReadPackage( "ctbllib", "tst/testinst.g" );
EOF
grep -Fvq fail log
rm -f log

# Somewhat less basic test
# Currently a couple of tests fail because of whitespace differences, and
# one test fails because we are not running Browse in a window.
gap -l "%{buildroot}%{_gap_dir};%{_gap_dir}" tst/testauto.g < /dev/null

# Do not run testall.g.  It takes several days to run.

%files
%doc README
%docdir %{_gap_dir}/pkg/%{pkgname}/doc
%docdir %{_gap_dir}/pkg/%{pkgname}/htm
%{_gap_dir}/pkg/%{pkgname}/

%changelog
* Wed Nov 11 2015 Jerry James <loganjerry@gmail.com> - 1.2.2-5
- Drop scriptlets; gap-core now uses rpm file triggers
- Rebuild documentation from source
- Turn test failures into build failures

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri Jan 30 2015 Jerry James <loganjerry@gmail.com> - 1.2.2-3
- Use redirection to force check script to terminate

* Thu Jan 29 2015 Jerry James <loganjerry@gmail.com> - 1.2.2-2
- Use _smp_mflags when compressing

* Fri Jan 16 2015 Jerry James <loganjerry@gmail.com> - 1.2.2-1
- Initial RPM
